Package com.google.javascript.jscomp

# Class PassConfig

java.lang.Object
com.google.javascript.jscomp.PassConfig

Direct Known Subclasses:
  `DefaultPassConfig`

public abstract class PassConfig extends Object
Pass factories and meta-data for native Compiler passes.

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static class`
`PassConfig.State`
Intermediate state for a running pass configuration.

## Constructor Summary

Constructors
Constructor
Description
`PassConfig(CompilerOptions options)`

## Method Summary

Modifier and Type
Method
Description
`protected abstract List<PassFactory>`
`getChecks()`
Gets the checking passes to run.
`protected abstract PassConfig.State`
`getIntermediateState()`
Get intermediate state for a running pass config, so it can be paused and started again later.
`protected abstract List<PassFactory>`
`getOptimizations()`
Gets the optimization passes to run.
`protected abstract void`
`setIntermediateState(PassConfig.State state)`
Set the intermediate state for a pass config, to restart a compilation process that had been previously paused.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### PassConfig

public PassConfig(CompilerOptions options)

## Method Details

### getChecks

protected abstract List<PassFactory> getChecks()
Gets the checking passes to run. Checking passes revolve around emitting warnings and errors. They also may include pre-processor passes needed to do error analysis more effectively. Clients that only want to analyze code (like IDEs) and not emit code will only run checks and not optimizations.

### getOptimizations

protected abstract List<PassFactory> getOptimizations()
Gets the optimization passes to run. Optimization passes revolve around producing smaller and faster code. They should always run after checking passes.

### getIntermediateState

protected abstract PassConfig.State getIntermediateState()
Get intermediate state for a running pass config, so it can be paused and started again later.

### setIntermediateState

protected abstract void setIntermediateState(PassConfig.State state)
Set the intermediate state for a pass config, to restart a compilation process that had been previously paused.